includeLibrary("/OpenForum/Javascript/mouse.js");
includeLibrary("/OpenForum/Javascript/xml.js");
includeLibrary("/OpenForum/Javascript/ajax.js");

tree = new function()
{

	this.buildTree = function buildTree( xmlElement,layerName )
	{
		this.root = new Node();

		this.root.buildFromXml( xmlElement );

		this.canvas = document.getElementById(layerName);

//alert(layerName+"="+this.canvas+"="+this.canvas.innerHTML+" : root="+this.root);
//alert(this.root.render());

                this.canvas.innerHTML=this.root.render();
                //this.canvas.innerHTML="<form name='"+layerName+"TreeForm' id='"+layerName+"TreeForm'>"+this.root.render()+"</form>";
	}
	
	this.toggleNode = function toggleNode( nodeId )
	{
	   nodes[nodeId].toggle();
	}

        this.toggleAction = 

	this.doAction = function doAction( nodeId )
	{
	   nodes[nodeId].select();
	}

	this.showForm = function showForm(nodeId)
	{
	   nodes[nodeId].openForm();
	}	
}

var selectedNode = null;
var openNode = null;
var nodes = new Array();
var nodeCount = 1;

function Node(title,href,action,icon,delayedRequest)
{
	this.children = new Array();

	if(action!="")
	{
		action = "onclick='"+action+"(\""+this.id+"\");return false;'";
	}

	this.title = title;
	this.action = action;
	this.path = "";
	this.href = href;
	this.vhref = href;
	this.extras = "";
	this.icon = icon;
	this.delayedRequest = delayedRequest;
	this.delayedRequestAction = null;
	this.level = 0;
	this.info = "";

	this.id = "node"+nodeCount;
	nodeCount++;

	this.source = null;

	nodes[ this.id ] = this;

	this.addChild = function addChild(title)
	{
		child = new Node(title);
		this.children[ this.children.length ] = child;

		return child;
	}

	this.buildFromXml = function buildFromXml(xmlElement)
	{
		this.source = xmlElement;

		name = xmlElement.getAttributeValue("title");
		href = xmlElement.getAttributeValue("href");
		vhref = xmlElement.getAttributeValue("vhref");
		path = xmlElement.getAttributeValue("path");
		action = xmlElement.getAttributeValue("action");
		icon = xmlElement.getAttributeValue("icon");
		info = xmlElement.getAttributeValue("info");
		extras = xmlElement.getAttributeValue("extras");
		delayedRequest = xmlElement.getAttributeValue("delayedRequest");
		delayedRequestAction = xmlElement.getAttributeValue("delayedRequestAction");
		if(name && name!="null")
		{
			this.title = name;
		}
		else
		{
			this.title = xmlElement.name;
		}

		if(extras && extras!="null")
		{
			this.extras = extras;
		}
		else
		{
			this.extras = '';
		}

		if(path && path!="null")
		{
			this.path = path;
		}
		else
		{
			this.path = '';
		}		

		if(href && href!="null")
		{
			this.href = href;
		}
		else
		{
			this.href = '';
		}
		
		if(vhref && vhref !="null")
		{
			this.vhref = vhref ;
		}
		else
		{
			this.vhref = href;
		}
		
		if(icon && icon!="null")
		{
			this.icon = icon;
		}
		else
		{
			this.icon = '/OpenForum/Images/icons/gif/attach.gif';
		}

		if(info && info!="null")
		{
			this.info = info;
		}
		else
		{
			this.info = '';
		}
		
		if(action && action!="null")
		{
			this.action = "onclick='"+action+"(\""+this.id+"\");return false;'";
		}
		else
		{
			this.action = "";
		}

		if(delayedRequest && delayedRequest!="null")
		{
			this.delayedRequest = delayedRequest;
		}


		if(delayedRequestAction && delayedRequestAction!="null")
		{
			this.delayedRequestAction = delayedRequestAction;
		}

		for(this.loop=0;this.loop<xmlElement.children.length;this.loop++)
		{
			node = this.addChild();
			node.buildFromXml( xmlElement.children[this.loop] );
		}
	}

	this.render = function render(level)
	{
		//alert("Rendering "+this.id+" Title:"+this.title);
		if(level)
		{
			this.level=level
		}
		else
		{
			this.level=0;
		}

		this.count = this.children.length;
		this.data = "";

		spacing = "";
		for(this.loop=0;this.loop<this.level;this.loop++)
		{
			spacing += "&nbsp;&nbsp;&nbsp;&nbsp;";
		}

		this.data+=spacing;
		
		if(this.count>0 || this.delayedRequest!=null)
		{
			this.data += "<a class='node' href='' onclick='tree.toggleNode(\""+this.id+"\");return false;'><img class='node' id='"+this.id+"Twistie' src='/OpenForum/Images/bullet_arrow_right.gif' border='0'></a>";
			if(this.href!=null && this.href!="")
			{
parts = this.vhref.split("/");
linkData = "";
path = "/";
for(loop=1;loop<parts.length;loop++)
{
  path += parts[loop]+"/";
  linkData += "<a href='"+path+"'>/"+parts[loop]+"</a>";
}

if(this.level==0)
{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><a href='"+this.vhref+"' "+action+" id='"+this.id+"Label' class='node' title='"+this.info+"'><img class='node' src='"+this.icon+"' border='0' class='nodeImg'></a>"+linkData+this.extras;
}
else
{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><a href='"+this.vhref+"' "+action+" id='"+this.id+"Label' class='node' title='"+this.info+"'><img class='node' src='"+this.icon+"' border='0' class='nodeImg'>"+this.title+"</a>"+this.extras;
}
			}
			else if(this.action!=null && this.action!="")
			{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><a href='' "+this.action+" id='"+this.id+"Label' class='node' title='"+this.info+"'><img src='"+this.icon+"' border='0' class='nodeImg'> "+this.title+"</a>"+this.extras;
			}
			else
			{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><img class='node' src='"+this.icon+"' border='0' class='nodeImg' title='"+this.info+"'> "+this.title+this.extras;
			}
		}
		else
		{
			this.data += "&nbsp;&nbsp;&nbsp;&nbsp;";

parts = this.vhref.split("/");
linkData = "";
path = "/";
for(loop=1;loop<parts.length;loop++)
{
  path += parts[loop]+"/";
  linkData += "<a href='"+path+"'>/"+parts[loop]+"</a>";
}

if(this.level==0)
{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><a href='"+this.vhref+"' "+action+" id='"+this.id+"Label' class='node' title='"+this.info+"'><img class='node' src='"+this.icon+"' border='0' class='nodeImg'></a>"+linkData+this.extras;
}
			else if(this.href!=null && this.href!="")
			{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><a href='"+this.vhref+"' "+this.action+" id='"+this.id+"Label' class='node' title='"+this.info+"'><img src='"+this.icon+"' border='0' class='nodeImg'>"+this.title+"</a>"+this.extras;
			}
			else if(this.action!=null && this.action!="")
			{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><a href='' "+this.action+" id='"+this.id+"Label' class='node' title='"+this.info+"'><img src='"+this.icon+"' border='0' class='nodeImg'> "+this.title+"</a>"+this.extras;
			}
			else
			{
				this.data += "  <span id='"+this.id+"Options' style='position: absolute;'></span><img src='"+this.icon+"' border='0' class='nodeImg' title='"+this.info+"'> "+this.title+this.extras;
			}
		}
		this.data += "<br/><DIV id='"+this.id+"' style='display: none;'>";

		this.count = this.children.length;

		for(this.loop=0;this.loop<this.count;this.loop++)
		{
			this.data += this.children[this.loop].render(this.level+1);
		}

		this.data += "</DIV>";

		return this.data;
	}

	this.toggle = function toggle()
	{
		if(selectedNode!=null && selectedNode!=this)
		{
			selectedNode.closeOptions();
		}

	   var node = document.getElementById(this.id);
	   var twistie = document.getElementById(this.id+"Twistie");

	   if(node.style.display=="block")
	   {
		node.style.display="none";
		twistie.src="/OpenForum/Images/bullet_arrow_right.gif";
	   }
	   else
	   {
	   	if(this.delayedRequest!=null)
	   	{
	   		script = ajax.doGet(this.delayedRequest,"pageName="+this.href);
			//alert(script);
	   		this.delayedRequest=null;
	   		
	   		newXml = eval( script );
	   		this.source.children=newXml.children;
			//alert("Evaluated "+script);
	   		children = newXml.children
	   		
	   		//alert("this.delayedRequestAction = "+this.delayedRequestAction);
layer = document.getElementById(this.id);
//layer.innerHTML = layer.innerHTML+"<form name='nodeForm"+this.source.ref+"' id='nodeForm"+this.source.ref+"'>";
//alert("new form nodeForm"+this.source.ref);
for(this.loopD=0;this.loopD<children.length;this.loopD++)
			{
                                if(this.delayedRequestAction!=null)
                                {
this.delayedRequestAction(children[this.loopD],this.source);
                                }
				newNode = new Node();
				newNode.buildFromXml( children[this.loopD] );
				rendered = newNode.render( this.level+1 );
				layer = document.getElementById(this.id);
				layer.innerHTML = layer.innerHTML+rendered;
//alert("Added node"+children[this.loopD].ref);
			}
//layer.innerHTML = layer.innerHTML+"</form>"
	   		
		}
		node.style.display="block";
		twistie.src="/OpenForum/Images/icons/gif/bullet_arrow_down.gif";
	   }
	}

	this.select = function select()
	{
		var node = document.getElementById(this.id+"Label");
		node.style.background="#000000";
		node.style.color="#FFFFFF";

		if(selectedNode!=null && selectedNode!=this)
		{
			selectedNode.deselect();
		}
		selectedNode = this;

		showAlert("Do Selected Action "+this.title,"");
	}

	this.openForm = function openForm()
	{
		if(openNode!=null)
		{
			openNode.closeForm();
		}
		openNode = this;
		html = ajax.doGet("/OpenForum/Actions/GetXmlNodeForm","pageName="+editPageName+"&fileName="+editFileName+"&viewName="+editViewName+"&nodePath="+this.path);

		var options = document.getElementById("options");
		var node = document.getElementById(this.id+"Options");

		node.innerHTML = "<br><table class='box'><tr><td>"+html+"<input type='Button' value='Cancel' onclick='nodes[\""+this.id+"\"].closeForm();return false;'></td></tr></table>";
	}

	this.closeForm = function closeOptions()
	{
		var node = document.getElementById(this.id+"Options");
		node.innerHTML="";
	}

	this.deselect = function deselect()
	{
		var node = document.getElementById(this.id+"Label");
		node.style.background="#FFFFFF";
		node.style.color="#000000";

		this.closeOptions();
	}
}
