package org.one.stone.soup.browser.security;

import java.io.*;
import java.net.*;
/*
 * Wet -Wired.com Browser Version Date 27-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.co.uk/pages/licence-os.html
 */

/**
 * @author nikcross
 *
 */

// TODO
interface SecurityInterface {
	public void checkAccept(String host, int port) throws SecurityException;
	public void checkAccess(Thread g) throws SecurityException;
	public void checkAccess(ThreadGroup g) throws SecurityException;
	public void checkAwtEventQueueAccess() throws SecurityException;
	public void checkConnect(String host, int port) throws SecurityException;
	public void checkConnect(String host, int port, Object context) throws SecurityException;
	public void checkCreateClassLoader() throws SecurityException;
	public void checkDelete(String file) throws SecurityException;
	public void checkExec(String cmd) throws SecurityException;
	public void checkExit(int status) throws SecurityException;
	public void checkLink(String lib) throws SecurityException;
	public void checkListen(int port) throws SecurityException;
	public void checkMemberAccess(Class clazz, int which) throws SecurityException;
	public void checkMulticast(InetAddress maddr) throws SecurityException;
	public void checkMulticast(InetAddress maddr, byte ttl) throws SecurityException;
	public void checkPackageAccess(String pkg) throws SecurityException;
	public void checkPackageDefinition(String pkg) throws SecurityException;
	public void checkPrintJobAccess() throws SecurityException;
	public void checkPropertiesAccess() throws SecurityException;
	public void checkPropertyAccess(String key) throws SecurityException;
	public void checkRead(FileDescriptor fd) throws SecurityException;
	public void checkRead(String file) throws SecurityException;
	public void checkRead(String file, Object context) throws SecurityException;
	public void checkSecurityAccess(String action) throws SecurityException;
	public void checkSetFactory() throws SecurityException;
	public void checkSystemClipboardAccess() throws SecurityException;
	public boolean checkTopLevelWindow(Object window) throws SecurityException;
	public void checkWrite(FileDescriptor fd) throws SecurityException;
	public void checkWrite(String file) throws SecurityException;
}
