package org.one.stone.soup.file;

import org.one.stone.soup.stringhelper.StringArrayHelper;
import org.one.stone.soup.stringhelper.StringGenerator;

public class FileDifferenceEngine {

	public static String getDifferences(String version1,String version2)
	{
		StringBuffer differences = new StringBuffer();

		version1 = StringGenerator.replace(version1,"\r","");
		String[] version1Text = StringArrayHelper.parseFields(version1,'\n');
		
		version2 = StringGenerator.replace(version2,"\r","");
		String[] version2Text = StringArrayHelper.parseFields(version2,'\n');

		int loop1=0;
		int loop2=0;
		for(int loop=0;loop1<version1Text.length && loop2<version2Text.length;loop++)
		{	
			if(version1Text[loop1].equals(version2Text[loop2]))	
			{
				differences.append( "  "+version1Text[loop1]+"\n" );
			}
			else
			{
				while(loop1<version1Text.length && loop2<version2Text.length && (version1Text[loop1].equals(version2Text[loop2]))==false)
				{
					int found = scanArrayForText(version2Text,loop2,version1Text[loop1]);
					if(found!=-1)
					{
						for(;loop2<found;loop2++)
						{
							differences.append( "- "+version2Text[loop2]+"\n" );
						}
						//continue;
						differences.append( "  "+version1Text[loop1]+"\n" );
					}					
					else
					{
						differences.append( "+ "+version1Text[loop1]+"\n" );
						loop2++;
					}
					loop1++;
				}
			}
			if(/*loop1>=version1Text.length || */loop1>=version1Text.length)
			{
				break;
			}
			loop1++;
			loop2++;
		}
		if(version1Text.length>loop1)
		{
			for(;loop1<version1Text.length;loop1++)
			{
				differences.append( "+ "+version1Text[loop1]+"\n" );
			}				
		}
		if(version2Text.length>loop2)
		{
			for(;loop2<version2Text.length;loop2++)
			{
				differences.append( "- "+version2Text[loop2]+"\n" );
			}				
		}
		
		return differences.toString();		
	}
	
	private static int scanArrayForText(String[] array,int offset,String text)
	{
		for(int loop=offset;loop<array.length;loop++)
		{
			if( array[loop].equals(text) )
			{
				return loop;
			}
		}
		return -1;
	}
}
