package org.one.stone.soup.grfx;

import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.image.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public class ImageFactory{

	public static Class root = ImageFactory.class;
	
	public static final Canvas DUMMY = new Canvas();
	public static ImageObserver observer = DUMMY;
	public static int TIMEOUT = 5;
	private static Image DOG = null;
	private static Image GRFXML_DOG = null;
	private static Image BAD_FILE = null;
	private static Image WAIT = null;



public static Image createHGradImage(Color colorA,Color colorB,int width,int height) {

	int data[] = new int[width*height];

	Color color;

	int redA=colorA.getRed();
	int greenA=colorA.getGreen();
	int blueA=colorA.getBlue();
	int alphaA=colorA.getAlpha();

	int redDiff = colorB.getRed()-redA;
	int greenDiff = colorB.getGreen()-greenA;
	int blueDiff = colorB.getBlue()-blueA;
	int alphaDiff = colorB.getAlpha()-alphaA;

	Pixel p = new Pixel();

	for(int loop=0;loop<width;loop++)
	{
		p.red = redA+((redDiff*loop)/width);
		p.green = greenA+((greenDiff*loop)/width);
		p.blue = blueA+((blueDiff*loop)/width);
		p.alpha = alphaA+((alphaDiff*loop)/width);

		for(int loopH=0;loopH<height;loopH++)
		{
			data[loop+(loopH*width)] = p.getRGB();
		}
	}

	MemoryImageSource mis = new MemoryImageSource(width,height,data,0,width);
	Image newImage = DUMMY.getToolkit().createImage(mis);

	while( newImage.getWidth(observer)==-1 || newImage.getHeight(observer)==-1 )
	{
		try{
			Thread.sleep(10);
		}catch(Exception e){}
	}

	return newImage;
}

public static Color getColorAt(Image image,int x,int y)
{
	int depth = 4;

	int scan = image.getWidth(observer);
	int[] data = new int[1];

	PixelGrabber pGrab = new PixelGrabber(image,x,y,x+1,y+1,data,0,scan);
	try{pGrab.grabPixels();}catch(Exception e){}

	return new Color(data[0]);
}

public static Image makeColorTransparent(Image image, final Color color)
{
	RGBImageFilter filter = new RGBImageFilter()
	{
		// Alpha bits are set to opaque, regardless of what they
		// might have been already.
		public int markerRGB = color.getRGB() | 0xFF000000;

		public final int filterRGB(int x, int y, int rgb)
		{
			if ( ( rgb | 0xFF000000 ) == markerRGB )
			{
				// Mark the alpha bits as zero - transparent,but
				// preserve the other information about the color
				// of the pixel.
				return 0x00FFFFFF & rgb;
			}
			else
			{
				// leave the pixel untouched
				return rgb;
			}
		}
	}; // end of inner class

	// Setup to use transparency filter
	ImageProducer ip = new FilteredImageSource(image.getSource(),filter);

	// Pull the old image thru this filter and create a new one
	return Toolkit.getDefaultToolkit().createImage(ip);
}

public static Image createImage(Color color,int width,int height) {

	int data[] = new int[width*height];

	Pixel p = new Pixel();
	p.alpha = 255;

	p.red=color.getRed();
	p.green=color.getGreen();
	p.blue=color.getBlue();

	for(int loop=0;loop<width*height;loop++)
	{
		data[loop] = p.getRGB();
	}

	MemoryImageSource mis = new MemoryImageSource(width,height,data,0,width);
	Image newImage = DUMMY.getToolkit().createImage(mis);

	while( newImage.getWidth(observer)==-1 || newImage.getHeight(observer)==-1 )
	{
		try{
			Thread.sleep(10);
		}catch(Exception e){}
	}

	return newImage;
}
public static Image createVGradImage(Color colorA,Color colorB,int width,int height) {

	int data[] = new int[width*height];

	Color color;

	int redA=colorA.getRed();
	int greenA=colorA.getGreen();
	int blueA=colorA.getBlue();
	int alphaA=colorA.getAlpha();

	int redDiff = colorB.getRed()-redA;
	int greenDiff = colorB.getGreen()-greenA;
	int blueDiff = colorB.getBlue()-blueA;
	int alphaDiff = colorB.getAlpha()-alphaA;

	Pixel p = new Pixel();

	for(int loop=0;loop<height;loop++)
	{
		p.red = redA+((redDiff*loop)/height);
		p.green = greenA+((greenDiff*loop)/height);
		p.blue = blueA+((blueDiff*loop)/height);
		p.alpha = alphaA+((alphaDiff*loop)/height);

		for(int loopW=0;loopW<width;loopW++)
		{
			data[loopW+(loop*width)] = p.getRGB();
		}
	}

	MemoryImageSource mis = new MemoryImageSource(width,height,data,0,width);
	Image newImage = DUMMY.getToolkit().createImage(mis);

	while( newImage.getWidth(observer)==-1 || newImage.getHeight(observer)==-1 )
	{
		try{
			Thread.sleep(10);
		}catch(Exception e){}
	}

	return newImage;
}
public static Image cutImage(Image source,int x,int y,int width,int height) {

	int scanWidth = source.getWidth( observer );
	int[] data = new int[ width*height ];

	PixelGrabber pGrab = new PixelGrabber(source,x,y,width,height,data,0,/*scanWidth*/width);
	try{
			pGrab.grabPixels();
		}catch(Exception e)
	{
		e.printStackTrace();
	}

	MemoryImageSource mis = new MemoryImageSource(width,height,data,0,width);

	Image img = DUMMY.getToolkit().createImage(mis);

	while( img.getWidth(observer)==-1 || img.getHeight(observer)==-1 )
	{
		try{
			Thread.sleep(10);
		}catch(Exception e){}
	}

	return img;
}
public static Image loadImage(java.io.InputStream iStream) throws ImageLoadException {

	Image newImage = null;
	try {
//		newImage = DUMMY.getToolkit().createImage( org.one.stone.soup.file.FileHelper.readFile(iStream) );
		newImage = new Canvas().getToolkit().createImage( org.one.stone.soup.file.FileHelper.readFile(iStream) );
	}
	catch(IOException io)
	{
		throw new ImageLoadException("Image stream failed to load. Exception:"+io.toString());
	}

	int width=newImage.getWidth(observer);
	int height=newImage.getHeight(observer);

	int loop=0;

	while((width==-1 || height==-1) && loop<TIMEOUT*100)
	{
		width=newImage.getWidth(observer);
		height=newImage.getHeight(observer);

		try{
			Thread.sleep(10);
		}
		catch(InterruptedException e)
		{
		}

		loop++;
	}

	if(loop==TIMEOUT*100)
	{
		throw new ImageLoadException("Image stream failed to load within "+TIMEOUT+" seconds");
	}

	return newImage;
}
public static Image loadImage(String imageFile) {

 try{
	Image image = null;
	 
	if(imageFile.length()>6 && imageFile.substring(0,6).equals("jar://"))
	{
		image = loadImage( root.getClassLoader().getResourceAsStream( imageFile.substring(6) ) );
	}
	else if(imageFile.length()>7 && imageFile.substring(0,7).equals("file://"))
	{
		image = new Canvas().getToolkit().createImage( imageFile.substring(7) );
	}
	else if(imageFile.length()>7 && imageFile.substring(0,7).equals("http://"))
	{
		try{
			image = loadImage( new URL(imageFile).openConnection().getInputStream() );
		}
		catch(IOException ioe)
		{
			image = null;
		}
	}
	else
	{
		image = new Canvas().getToolkit().createImage( new java.io.File(imageFile).getAbsolutePath() );
	}
	int width = image.getWidth(observer);
	int height = image.getHeight(observer);
	int loop=0;
	
	while((width==-1 || height==-1) && loop<TIMEOUT*100)
	{
		width=image.getWidth(observer);
		height=image.getHeight(observer);

		try{
			Thread.sleep(10);
		}
		catch(InterruptedException e)
		{
		}

		loop++;
	}

	if(loop==TIMEOUT*100)
	{
		throw new ImageLoadException("Image stream failed to load within "+TIMEOUT+" seconds");
	}
	
	 return image;
 }
 /*catch(FileNotFoundException fe)
 {
	 System.err.println("File '"+new java.io.File(imageFile).getAbsolutePath()+"' not found.");

	 if(!imageFile.equals("jar://resources/bad-file.png"))
	 {
	 	return loadImage("jar://resources/bad-file.png");
	 } 	
 }*/
 catch(ImageLoadException ie)
 {
	 System.err.println("File '"+new java.io.File(imageFile).getAbsolutePath()+"' not found.");

	 if(!imageFile.equals("jar://resources/bad-file.png"))
	 {
	 	return loadImage("jar://resources/bad-file.png");
	 }
 }
 
 return null;
}
public static Image loadImage(URL imageUrl) throws ImageLoadException {
 try{
	return loadImage( imageUrl.openStream() );
 }
 catch(MalformedURLException me)
 {
	 throw new ImageLoadException("URL '"+imageUrl+"' is invalid.");
 }
 catch(IOException ie)
 {
	 throw new ImageLoadException("URL '"+imageUrl+"' failed to load. "+ie);
 }
}
public static Image resizeImage(Image source,int width,int height,boolean max) throws ImageLoadException
{
	if(max)
	{
		Dimension bounds = getImageBoundedSize(source,width,height);
		width = bounds.width;
		height = bounds.height;
	}

	Image target = source.getScaledInstance(width,height,Image.SCALE_SMOOTH);

	int loop=0;

	while((width!=target.getWidth(observer) || height!=target.getHeight(observer)) && loop<TIMEOUT*100)
	{
		try{
			Thread.sleep(10);
		}
		catch(InterruptedException e)
		{
		}

		loop++;
	}

	if(loop==TIMEOUT*100)
	{
		throw new ImageLoadException("Image failed to scale within "+TIMEOUT+" seconds");
	}

	return target;
}

public static Dimension getImageBoundedSize(Image image,int maxWidth,int maxHeight)
{
	double width = image.getWidth(observer);
	double widthFactor = 1;
	if(width>maxWidth)
	{
		widthFactor = maxWidth/width;
	}

	double heightFactor = 1;
	double height = image.getHeight(observer);
	if(height>maxHeight)
	{
		heightFactor = maxHeight/height;
	}

	double factor = 1;
	if(widthFactor!=1)
	{
		factor = widthFactor;
	}
	if(heightFactor<factor)
	{
		factor = heightFactor;
	}

	Dimension newSize = new Dimension();

	newSize.width = (int)(width*factor);
	newSize.height = (int)(height*factor);

	return newSize;
}

public static BufferedImage createBufferedImage(Image image)
{
	BufferedImage bufferedImage = new BufferedImage(image.getWidth(observer),image.getHeight(observer),BufferedImage.TYPE_INT_ARGB);
	Graphics grfx = bufferedImage.getGraphics();
	grfx.drawImage(image,0,0,image.getWidth(observer),image.getHeight(observer),observer);

	return bufferedImage;
}

public static BufferedImage createResizedBufferedImage(Image image,int width,int height,boolean max)
{
	if(max)
	{
		Dimension bounds = getImageBoundedSize(image,width,height);
		width = bounds.width;
		height = bounds.height;
	}
	
	BufferedImage bufferedImage = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
	Graphics2D grfx = (Graphics2D)bufferedImage.getGraphics();
	grfx.setRenderingHint(RenderingHints.KEY_INTERPOLATION,RenderingHints.VALUE_INTERPOLATION_BILINEAR);
	grfx.drawImage(image,0,0,width,height,observer);

	return bufferedImage;
}

public static void setImageObserver(ImageObserver newObserver)
{
	observer = newObserver;
}

public static void releaseImageObserver()
{
	observer = DUMMY;
}

}
