package org.one.stone.soup.grfx;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.io.FileOutputStream;
import java.io.OutputStream;

import javax.imageio.ImageIO;
/**
 * Insert the type's description here.
 * Creation date: (23/05/03 18:01:21)
 * @author:
 */
public class ThumbNailMaker implements ImageObserver,Runnable{

	private boolean imageReady = false;
	private boolean thumbReady = false;

	private Image image;
	private BufferedImage bThumb;
	
	private String imageFile;
	private String thumbFile;
	private String format;
	private int width;
	private int height;
/**
 * ThumbNailMaker constructor comment.
 */
public ThumbNailMaker(String imageFile,String thumbFile,String format,int width,int height,boolean asynchronous)
{
	super();

	this.imageFile=imageFile;
	this.thumbFile=thumbFile;
	this.format=format;
	this.width=width;
	this.height=height;	
	
	if(asynchronous)
	{
		new Thread(this,"Making thumbnail for "+imageFile).start();
	}
	else
	{
		run();
	}
}
public void run()
{
		imageReady = false;
		thumbReady = false;

		try{
			ImageFactory.setImageObserver( this );
			image = org.one.stone.soup.grfx.ImageFactory.loadImage(imageFile);
			int count = 0;
			while( imageReady==false )
			{
				try{Thread.sleep(100);}catch(Exception e){}

				count++;
				if(count>100)
				{
					System.out.println("Thumbnail failed for "+imageFile);
					break;
				}
			}

			bThumb = org.one.stone.soup.grfx.ImageFactory.createResizedBufferedImage( image,width,height,true );

			count = 0;
			while( thumbReady==false )
			{
				try{Thread.sleep(100);}catch(Exception e){}
				count++;
				if(count>100)
				{
					System.out.println("Thumbnail failed for "+imageFile);
					break;
				}
			}

			
			/*if(count>100)
			{
				System.out.println("Thumbnail failed for "+imageFile);
				ImageFactory.releaseImageObserver();
				return;
			}*/

			OutputStream oStream = new FileOutputStream(thumbFile);

			//JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder( oStream );
			//encoder.encode( bThumb );
			
			ImageIO.write(bThumb,format,oStream);
			oStream.flush();
			oStream.close();

	//		ImageFactory.releaseImageObserver();

	// Test show frame
	/*		org.one.stone.soup.swing.WetWiredJFrame test = new org.one.stone.soup.swing.WetWiredJFrame("Thumbnail test");

			javax.swing.JButton button = new javax.swing.JButton( new javax.swing.ImageIcon(image) );
			test.getContentPane().add(button,BorderLayout.SOUTH);

			button = new javax.swing.JButton( new javax.swing.ImageIcon(thumb) );
			test.getContentPane().add(button,BorderLayout.CENTER);

			button = new javax.swing.JButton( new javax.swing.ImageIcon(bThumb) );
			test.getContentPane().add(button,BorderLayout.NORTH);

			test.pack();
			test.show();*/
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}

	//ImageFactory.releaseImageObserver();
}

public boolean imageUpdate(
		Image img,
		int infoflags,
		int x,
		int y,
		int width,
		int height
	)
	{
		//System.out.println("Info:"+infoflags);

		if( infoflags==32)
		{
			if(img==image)
			{
				System.out.println("Image ready");
				ImageFactory.releaseImageObserver();
				imageReady = true;
				return false;
			}
			else if(img==bThumb)
			{
				System.out.println("Thumb ready");
				ImageFactory.releaseImageObserver();
				thumbReady = true;
				return false;
			}
			else
			{
				System.out.println("Wrong image");
				return true;
			}
		}

		return true;
	}

}
