package org.one.stone.soup.math;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

// TODO
public final class IntMath{

	public static final double FACTOR = 1024;
	public static final int SHIFT = 10;
	public static final double A_TO_R = 0.017453277;
	public static final double R_TO_A = 1/0.017453277;

	private static int intCos[];
	private static int intSin[];
	private static int intTan[];

	private static java.util.Random random=new java.util.Random();


	static{
		int loop;
		intSin = new int[360];
		intCos = new int[360];
		intTan = new int[360];

		for(loop=0;loop<360;loop++)
		{
			intSin[loop]=(int)(
			Math.sin((double)loop*A_TO_R)
			*FACTOR
			);
			intCos[loop]=(int)(
			Math.cos((double)loop*A_TO_R)
			*FACTOR
			);
			intTan[loop]=(int)(
			Math.tan((double)loop*A_TO_R)
			*FACTOR
			);
		}
	}

/**
 * This method was created in VisualAge.
 * @return double
 * @param angle int
 */
public static int acos(int a,int b) {
	return (int)(Math.acos((double)a/(double)b)/A_TO_R);
}
/**
 *
 * @return int
 * @param x int
 * @param y int
 */
public static int angle(int x, int y) {

	int l = org.one.stone.soup.math.IntMath.distance(x,y);
	int d = acos(x,l);
	if(y<0)
		d = 360-d;

	return d;
}
/**
 * This method was created in VisualAge.
 * @return double
 * @param angle int
 */
public static int asin(int a,int b) {
	return (int)(Math.asin((double)a/(double)b)/A_TO_R);
}
/**
 * This method was created in VisualAge.
 * @return double
 * @param angle int
 */
public static int atan(int a,int b) {
	return (int)(Math.atan((double)a/(double)b)/R_TO_A);
}
	private static int boundAngle(int angle)
	{
		while(angle<0)
			angle+=360;
		while(angle>359)
			angle-=360;

		return(angle);
	}
	public static int cos(int angle,int value)
	{
		angle = boundAngle(angle);
		return((intCos[angle]*value)>>SHIFT);
	}
/**
 * This method was created in VisualAge.
 * @return double
 * @param angle int
 */
public static double dcos(int angle) {
	return Math.cos((double)angle*A_TO_R);
}
public static int distance(int x, int y) {

	double v = ((double)y*(double)y) + ((double)x*(double)x);

	return (int)Math.pow(v,0.5);
}
public static int distance(int x, int y,int z) {

	double xy = ((double)y*(double)y) + ((double)x*(double)x);
	xy = Math.pow(xy,0.5);

	double xz = ((double)z*(double)z) + ((double)x*(double)x);
	xz = Math.pow(xz,0.5);

	double v = ((double)xz*(double)xz) + ((double)xy*(double)xy);

	return (int)Math.pow(v,0.5);
}
/**
 * This method was created in VisualAge.
 * @return double
 * @param angle int
 */
public static double dsin(int angle) {
	return Math.sin((double)angle*A_TO_R);
}
/**
 * This method was created by Nik Cross.
 * @return int
 */
public static int random(int max) {

	if(max==0)
		return 0;

	int value=random.nextInt()%max;
	if(value<0)
		value*=-1;

	return value;
}
	public static int sin(int angle,int value)
	{
		angle = boundAngle(angle);
		return((intSin[angle]*value)>>SHIFT);
	}
	public static int tan(int angle,int value)
	{
		angle = boundAngle(angle);
		return((intTan[angle]*value)>>SHIFT);
	}
}
