package org.one.stone.soup.swing;

import java.io.File;
import java.util.Hashtable;

import javax.imageio.ImageIO;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileSystemView;

import org.one.stone.soup.javahelper.JavaNameHelper;
import org.one.stone.soup.stringhelper.StringArrayHelper;

public class JImageChooser extends JFileChooser {

	public JImageChooser(File currentDirectory, FileSystemView fsv)
	{
		super(currentDirectory,fsv);
		createChoiceView();
	}

	public JImageChooser(String currentDirectoryPath, FileSystemView fsv)
	{
		super(currentDirectoryPath,fsv);
		createChoiceView();
	}
	
	private void createChoiceView()
	{
		String[] types = ImageIO.getReaderFormatNames();
		types = StringArrayHelper.sort(types,StringArrayHelper.ASCENDING);

		addChoosableFileFilter( new SimpleFileFilter(types,"All Image Files" ) );
		
		Hashtable typesTable = new Hashtable();
		for(int loop=0;loop<types.length;loop++)
		{
			types[loop] = types[loop].toLowerCase();
			if(typesTable.get(types[loop])!=null)
			{
				continue;
			}
			typesTable.put(types[loop],types[loop]);
			addChoosableFileFilter( new SimpleFileFilter(types[loop],JavaNameHelper.dataToTitleName( types[loop]) ) );
		}

		ImagePreviewAccessory ipv = new ImagePreviewAccessory(this);
		addActionListener(ipv);
		addPropertyChangeListener(ipv);
		setAccessory(ipv);
	}

	
	public JImageChooser() {
		this((File) null, (FileSystemView) null);
	}

	public JImageChooser(File currentDirectory) {
		this(currentDirectory, (FileSystemView) null);
	}

	public JImageChooser(FileSystemView fsv) {
		this((File) null, fsv);
	}

	public JImageChooser(String currentDirectoryPath) {
		this(currentDirectoryPath,(FileSystemView) null);
	}	
}
