package org.one.stone.soup.util;

import java.awt.*;
import java.awt.event.*;

/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 * @deprecated Use java.util.Timer
 */

// TODO
/*
 * Wet-Wired.com Library Version 2.1
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.wet-wired.com/licence/license-os.html
 */

 /**
	* The TimeWatch class calls the actionPerformed method of registered
	* listeners implementing the ActionListener when the time period has
	* elapsed.
	*
*/

public class TimeWatch implements Runnable{

	private long wait;
	private String actionCommand="ready";
	private Object source;

	private ActionListener actionListener;

	private boolean running=false;
	private boolean looped=false;

	private long endTime;
	private long startTime;

	private long count = 0;
public TimeWatch(long waitTimeMilliSeconds) {
	super();

	wait=waitTimeMilliSeconds;
}
public TimeWatch(long waitTime,String actionCommand) {
	super();

	wait=waitTime;
	this.actionCommand = actionCommand;
}
public TimeWatch(long waitTime,String actionCommand,Object source) {
	super();

	wait=waitTime;
	this.actionCommand = actionCommand;
	this.source = source;
}
	public synchronized void addActionListener(ActionListener l) {
		actionListener = AWTEventMulticaster.add(actionListener, l);
	}
/**
 *
 * @return java.lang.String
 */
public String getActionCommand() {
	return actionCommand;
}
/**
 *
 * @return int
 */
public long getCount() {
	return count;
}
/**
 *
 * @return long
 */
public long getWait() {
	return wait;
}
private void processActionEvent(ActionEvent e) {
	if (actionListener != null) {
		actionListener.actionPerformed(e);
	}
}
	public synchronized void removeActionListener(ActionListener l) {
		actionListener = AWTEventMulticaster.remove(actionListener, l);
	}
public void resetTimer()
{
	startTime = System.currentTimeMillis();

	endTime = startTime+wait;
}
public void run()
{
	if(running)
		return;

	running=true;

	while(running)
	{
		while(running)
		{
			try{Thread.sleep(10);}catch(Exception e){}//dummy catch
	
			if(System.currentTimeMillis()>=endTime)
				break;
		}
	
		count++;
		running=false;
	
		if(System.currentTimeMillis()>=endTime)
		{
			if(source==null)
				processActionEvent(new ActionEvent(this,0,actionCommand));
			else
				processActionEvent(new ActionEvent(source,0,actionCommand));
		}
		
		if(looped)
		{
			resetTimer();
			running = true;
		}
	}

}
public void setActionCommand(String newActionCommand) {
	actionCommand = newActionCommand;
}
public void setWait(long newWait) {
	wait = newWait;
}
public void startTimer()
{
	resetTimer();
	Thread thread = new Thread(this,"Timer:"+actionCommand);
	thread.start();
}
public void stopTimer()
{
	running=false;
	looped = false;
}
public boolean isLooped() {
	return looped;
}
public void setLooped(boolean looped) {
	this.looped = looped;
}
}
