package org.one.stone.soup.xml;

import org.one.stone.soup.exception.*;

/*
 * Wet-Wired.com Xml Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

 /**
  * An XmlParseException is thrown by the parser when an error is found in an Xml
  * document. Where possible the exception gives a reason and the lines in the file
  * where the error has occured.
 */

public class XmlParseException extends ExceptionTemplate {

	public static final int UNKNOWN_CODE = 0;

	public static final int END_TAG_MISMATCH=1;
	public static final int UNEXPECTED_END_OF_TAG=2;
	public static final int UNEXPECTED_END_OF_VALUE=3;
	public static final int FAILED_TO_IMPORT_FILE=4;
	public static final int EMPTY_TAG=5;
	public static final int CURRENT_FILE=6;
	public static final int NO_FILE_TO_IMPORT=7;
	public static final int FAILED_TO_FIND_FILE=8;

	static{
		message = new String[9];

		message[UNKNOWN_CODE]="Unknown exception code #.";
		message[END_TAG_MISMATCH]="Error found at line #. The close tag '#' does not match current tag '#' for element starting at #.";
		message[EMPTY_TAG]="Error found at line #.An empty tag was found.";
		message[UNEXPECTED_END_OF_TAG]="The file ended prematurly with '#' at line # with an exception #.";
		message[UNEXPECTED_END_OF_VALUE]="The file ended prematurly with '#' at line # with an exception #,";
		message[FAILED_TO_IMPORT_FILE]="The import of file '#' at line # failed with an exception #.";
		message[CURRENT_FILE]="Error found in file #.";
		message[NO_FILE_TO_IMPORT]="The import tag at line # has no url or file attribute #.";
		message[FAILED_TO_FIND_FILE]="The file # was not found.";
	}
/**
 * IGMLException constructor comment.
 * @param code int
 * @param data java.lang.Object[]
 */
public XmlParseException(int code, java.lang.Object[] data) {
	super(code, data);
}
public XmlParseException(int code, int lineNo) {
	super(code, new Object[]{new Integer(lineNo)} );
}
}
