package org.one.stone.soup.xml.helper;

import java.util.*;

import org.one.stone.soup.xml.*;

/*
 * Wet-Wired.com Xml Helpers Version Date 25-Aug-2004
 *
 * Copyright 2000-2001 by Wet-Wired.com Ltd.,
 * Portsmouth England
 * This software is OSI Certified Open Source Software
 * This software is covered by an OSI approved open source licence
 * which can be found at http://www.onestonesoup.org/OSSLicense.html
 */

/**
 * @author nikcross
 *
 */

public class XmlTraverser
{
	private Vector elements = new Vector();
	private int cursor = 0;

public XmlTraverser(XmlElement target) {
	super();

	addElement(null,null,target);
}

private void addElement(String path,XmlElement parent,XmlElement element)
{
	if(element==null)
	{
		return;
	}
	XmlElement container = new XmlElement("container");

	int level = element.getLevel();
	container.addChild(element);
	element.setLevel(level);

	if(parent!=null)
	{
		level = parent.getLevel();
		container.addChild(parent);
		parent.setLevel(level);
	}
	else
	{
		container.addChild("_null");
	}

	if(path==null)
	{
		path = element.getName();
	}
	else
	{
		path = path+"/"+element.getName();
	}
	container.addDataItem(path);

	elements.add(container);

	for(int loop=0;loop<element.getElementCount();loop++)
	{
		addElement(path,element,element.getElementByIndex(loop));
	}
}

public int getElementCount() {
	return elements.size();
}

public XmlElement getParent()
{
	XmlElement parent = ((XmlElement)elements.elementAt(cursor-1)).getElementByIndex(1);

	if(parent.getName().equals("_null"))
	{
		return null;
	}
	else
	{
		return parent;
	}
}

public String getPath()
{
	return (String)(((XmlElement)elements.elementAt(cursor-1)).getData(2));
}

public boolean hasMoreElements() {

	if(cursor<elements.size())
	{
		return true;
	}
	else
	{
		return false;
	}
}

public XmlElement nextElement()
{
	cursor++;
	return ((XmlElement)elements.elementAt(cursor-1)).getElementByIndex(0);
}
}
